//---------------------------------------------------------------------------
//
// Evj        Model the evolution of DNA binding site recognition
//
// Module:
// Author:    Paul C. Anagnostopoulos
// Created:   1 April 2005
//
// This computer program fits the description in the U.S. Copyright Act
// of a "United States Government work." It was written as a part of
// my/our official duties as a Government employee. This means it cannot
// be copyrighted. The program is freely available for use without a
// copyright notice, and there are no restrictions on its use, now or
// subsequently. We retain no rights in the program. Please acknowledge
// the source of this code in any releases you make.
//
//---------------------------------------------------------------------------


//                      Debugging
//                      ---------


public class Debug
{
  public static void trace (String tag)
  {
    System.out.println("<<" + tag + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj)
  {
    System.out.println("<<" + tag + ": " + obj.toString() + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj1, Object obj2)
  {
    System.out.println("<<" + tag + ": " + obj1.toString() + ", " +
                       obj2.toString() + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj1, Object obj2, Object obj3)
  {
    System.out.println("<<" + tag + ": " + obj1.toString() + ", " +
                       obj2.toString() + ", " +
                       obj3.toString() + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj1, Object obj2,
                            Object obj3, Object obj4)
  {
    System.out.println("<<" + tag + ": " + obj1.toString() + ", " +
                       obj2.toString() + ", " +
                       obj3.toString() + ", " +
                       obj4.toString() + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj1, Object obj2,
                            Object obj3, Object obj4, Object obj5)
  {
    System.out.println("<<" + tag + ": " + obj1.toString() + ", " +
                       obj2.toString() + ", " +
                       obj3.toString() + ", " +
                       obj4.toString() + ", " +
                       obj5.toString() + ">>");
    System.out.flush();
  }

  public static void trace (String tag, Object obj1, Object obj2,
                            Object obj3, Object obj4, Object obj5,
                            Object obj6)
  {
    System.out.println("<<" + tag + ": " + obj1.toString() + ", " +
                       obj2.toString() + ", " +
                       obj3.toString() + ", " +
                       obj4.toString() + ", " +
                       obj5.toString() + ", " +
                       obj6.toString() + ">>");
    System.out.flush();
  }

///  public static void traceMatrix (String tag, int matrix[][])
///  {
///    System.out.print("<<" + tag + ":");
///    for (int b = 0; b <= 3; ++b) {
///      for (int p = 0; p < Param.siteWidth(); ++p)
///        System.out.print(" " + ((Integer) matrix[b][p]).toString());
///      System.out.println();
///    }
///    System.out.println(">>");
///  }
///
///  public static void traceMatrix (String tag, float matrix[][])
///  {
///    System.out.print("<<" + tag + ":");
///    for (int b = 0; b <= 3; ++b) {
///      for (int p = 0; p < Param.siteWidth(); ++p)
///        System.out.print(" " + ((Float) matrix[b][p]).toString());
///      System.out.println();
///    }
///    System.out.println(">>");
///  }
}
